
function [RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);

[DD NN] = size(XX);
[DD FF KK] = size(LX);
oneNN = ones(1,NN);
oneKK = ones(1,KK);
oneFF = ones(1,FF);
eyeFF = eye(FF);

const = -DD/2*log(2*pi);
RR  = zeros(KK,NN);
ZZ  = zeros(FF,NN,KK);

%tic

  % E step
  pi = 1./PX;
  for kk=1:KK,
    l        = LX(:,:,kk);
    ltpi     = (pi(:,oneFF).*l)';
    ltpil    = ltpi*l;
    iltpil   = eyeFF + ltpil;
    cc       = chol(iltpil);
    cci      = inv(cc);
    covz     = cci*cci';
    delta    = XX-MX(:,kk*oneNN);
    meanz    = ((eyeFF-ltpil*covz)*ltpi)*delta;

    ZZ(:,:,kk)  = meanz;
    RR(kk,:)    = -.5*(pi'*(delta.*delta) - sum(meanz.*(iltpil*meanz),1)) - ...
                  sum(log(diag(cc)));
  end;

  RR = RR + const + .5*sum(log(pi));
  mm = max(RR,[],1);
  RR = exp(RR-mm(oneKK,:));
  ss = sum(RR,1);
  RR = RR./ss(oneKK,:);

%time=toc;
%fprintf(1,'   [time %f]\n',time);
