function plotmfa3(Lh,Mu,Ph,plotparams,pp2);

if(nargin<5) pp2{1}='c-'; pp2{2}='linewidth'; pp2{3}=1; end
if(nargin<4) plotparams{1}='k'; plotparams{2}='linewidth'; plotparams{3}=2; end

Ph = diag(Ph);
th = (0:.01:2*pi)';

hh = ishold;
if ~hh, cla; end;
hold on;

for ii=1:size(Mu,2),
  ll = Lh(:,:,ii);
  uu = Mu(:,ii);
  phi = Ph + ll*ll';
  [vv,dd] = eig(phi);
  dd = sqrt(diag(dd));
  for jj=1:3,
    kk=rem(jj,3)+1;
    xx = uu(1) + cos(th)*vv(1,jj)*dd(jj) + sin(th)*vv(1,kk)*dd(kk);
    yy = uu(2) + cos(th)*vv(2,jj)*dd(jj) + sin(th)*vv(2,kk)*dd(kk);
    zz = uu(3) + cos(th)*vv(3,jj)*dd(jj) + sin(th)*vv(3,kk)*dd(kk);
    plot3(xx,yy,zz,plotparams{:});
  end;

  if(~isempty(pp2))
    for ff=1:size(ll,2),
      fl=[uu uu+ll(:,1)];
      plot3(fl(1,:),fl(2,:),fl(3,:),'c-','linewidth',1);
    end;
  end;
end

if hh, hold on; else hold off; end;
