% XX = y2x(YY,LX,MX,PX,Pi,LY,MY);
%
%   Computes XX from YY given parameters of LLC embedding.
%

function XX = y2x(YY,LX,MX,PX,Pi,LY,MY,PY);

[DD FF KK] = size(LX);
NN = size(YY,2);
kf = KK*(FF+1);
oneFF = ones(1,FF+1);

LX(:,end+1,:) = reshape(MX,[DD 1 KK]);
LX = reshape(permute(LX,[3 2 1]),[kf DD]);

[RR,ZZ] = infermfa(YY,LY,MY,PY,Pi);

RR = reshape(RR,[1 KK NN]);
ZZ(end+1,:,:) = 1;
ZZ = permute(ZZ,[1 3 2]);
UU = reshape(permute(RR(oneFF,:,:).*ZZ,[3 2 1]),[NN kf]);

XX = (UU*LX)';

